Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/DefaultJTopologyReportView.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/DefaultJTopologyReportView.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/DefaultJTopologyReportView.java	(revision 727)
@@ -29,17 +29,21 @@
    JLabel lblShow = new JLabel();
    JComboBox cboRules = new JComboBox();
    JToggleButton btnVisibleExtentOnly = new JToggleButton();
-   JButton btnZoom = new JButton();
-   JButton btnCenter = new JButton();
+   JButton btnZoomGeometry = new JButton();
    JButton btnActions = new JButton();
    JButton btnRefresh = new JButton();
    JToggleButton btnShowErrors = new JToggleButton();
    JToggleButton btnShowExceptions = new JToggleButton();
+   JToggleButton btnShowForm = new JToggleButton();
+   JButton btnCenterError = new JButton();
+   JButton btnCenterGeometry = new JButton();
+   JButton btnZoomError = new JButton();
+   JButton btnEraseErrorMarks = new JButton();
    JPanel pnlParameters = new JPanel();
+   JLabel lblActionDescription = new JLabel();
+   JLabel lblActionTitle = new JLabel();
    JButton btnParametersCancel = new JButton();
    JButton btnParametersAccept = new JButton();
-   JLabel lblActionDescription = new JLabel();
-   JLabel lblActionTitle = new JLabel();
    JLabel lblTaskStatusMessage = new JLabel();
    JProgressBar pbTaskStatusProgress = new JProgressBar();
    JButton btnTaskStatusCancel = new JButton();
@@ -171,7 +175,7 @@
    public JPanel createPanel2()
    {
       JPanel jpanel1 = new JPanel();
-      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
+      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:8DLU:NONE,FILL:DEFAULT:NONE,FILL:8DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
       CellConstraints cc = new CellConstraints();
       jpanel1.setLayout(formlayout1);
 
@@ -182,56 +186,84 @@
       cboRules.setName("cboRules");
       jpanel1.add(cboRules,cc.xy(3,1));
 
-      btnVisibleExtentOnly.setIcon(loadImage("org/gvsig/topology/swing/impl/images/visible_extent.png"));
+      btnVisibleExtentOnly.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-report-filter-visible-extent.png"));
       btnVisibleExtentOnly.setName("btnVisibleExtentOnly");
       btnVisibleExtentOnly.setToolTipText("_Show_only_in_visible_extent");
       EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
       btnVisibleExtentOnly.setBorder(emptyborder1);
       jpanel1.add(btnVisibleExtentOnly,cc.xy(9,1));
 
-      btnZoom.setIcon(loadImage("org/gvsig/topology/swing/impl/images/zoom.png"));
-      btnZoom.setName("btnZoom");
-      btnZoom.setToolTipText("_Zoom");
+      btnZoomGeometry.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-report-zoom-geometry.png"));
+      btnZoomGeometry.setName("btnZoomGeometry");
+      btnZoomGeometry.setToolTipText("_Zoom");
       EmptyBorder emptyborder2 = new EmptyBorder(2,2,2,2);
-      btnZoom.setBorder(emptyborder2);
-      jpanel1.add(btnZoom,cc.xy(11,1));
+      btnZoomGeometry.setBorder(emptyborder2);
+      jpanel1.add(btnZoomGeometry,cc.xy(13,1));
 
-      btnCenter.setIcon(loadImage("org/gvsig/topology/swing/impl/images/center_view.png"));
-      btnCenter.setName("btnCenter");
-      btnCenter.setToolTipText("_Center");
-      EmptyBorder emptyborder3 = new EmptyBorder(2,2,2,2);
-      btnCenter.setBorder(emptyborder3);
-      jpanel1.add(btnCenter,cc.xy(13,1));
-
-      btnActions.setIcon(loadImage("org/gvsig/topology/swing/impl/images/show_actions.png"));
+      btnActions.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-report-actions.png"));
       btnActions.setName("btnActions");
       btnActions.setToolTipText("_Actions");
-      EmptyBorder emptyborder4 = new EmptyBorder(2,2,2,2);
-      btnActions.setBorder(emptyborder4);
-      jpanel1.add(btnActions,cc.xy(15,1));
+      EmptyBorder emptyborder3 = new EmptyBorder(2,2,2,2);
+      btnActions.setBorder(emptyborder3);
+      jpanel1.add(btnActions,cc.xy(23,1));
 
-      btnRefresh.setIcon(loadImage("org/gvsig/topology/swing/impl/images/refresh.png"));
+      btnRefresh.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-report-refresh.png"));
       btnRefresh.setName("btnRefresh");
       btnRefresh.setToolTipText("_Update");
-      EmptyBorder emptyborder5 = new EmptyBorder(2,2,2,2);
-      btnRefresh.setBorder(emptyborder5);
-      jpanel1.add(btnRefresh,cc.xy(17,1));
+      EmptyBorder emptyborder4 = new EmptyBorder(2,2,2,2);
+      btnRefresh.setBorder(emptyborder4);
+      jpanel1.add(btnRefresh,cc.xy(25,1));
 
-      btnShowErrors.setIcon(loadImage("org/gvsig/topology/swing/impl/images/show_errors.png"));
+      btnShowErrors.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-report-filter-errors.png"));
       btnShowErrors.setName("btnShowErrors");
-      btnShowErrors.setToolTipText("_Show_only_in_visible_extent");
-      EmptyBorder emptyborder6 = new EmptyBorder(2,2,2,2);
-      btnShowErrors.setBorder(emptyborder6);
+      btnShowErrors.setToolTipText("_Show_errors");
+      EmptyBorder emptyborder5 = new EmptyBorder(2,2,2,2);
+      btnShowErrors.setBorder(emptyborder5);
       jpanel1.add(btnShowErrors,cc.xy(5,1));
 
-      btnShowExceptions.setIcon(loadImage("org/gvsig/topology/swing/impl/images/show_exceptions.png"));
+      btnShowExceptions.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-report-filter-exceptions.png"));
       btnShowExceptions.setName("btnShowExceptions");
-      btnShowExceptions.setToolTipText("_Show_only_in_visible_extent");
-      EmptyBorder emptyborder7 = new EmptyBorder(2,2,2,2);
-      btnShowExceptions.setBorder(emptyborder7);
+      btnShowExceptions.setToolTipText("_Show_exceptions");
+      EmptyBorder emptyborder6 = new EmptyBorder(2,2,2,2);
+      btnShowExceptions.setBorder(emptyborder6);
       jpanel1.add(btnShowExceptions,cc.xy(7,1));
 
-      addFillComponents(jpanel1,new int[]{ 2,4,6,8,10,12,14,16 },new int[0]);
+      btnShowForm.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-report-show-form.png"));
+      btnShowForm.setName("btnShowForm");
+      btnShowForm.setToolTipText("_Show_form_when_modify_geometry");
+      EmptyBorder emptyborder7 = new EmptyBorder(2,2,2,2);
+      btnShowForm.setBorder(emptyborder7);
+      jpanel1.add(btnShowForm,cc.xy(11,1));
+
+      btnCenterError.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-report-center-error.png"));
+      btnCenterError.setName("btnCenterError");
+      btnCenterError.setToolTipText("_Center_error");
+      EmptyBorder emptyborder8 = new EmptyBorder(2,2,2,2);
+      btnCenterError.setBorder(emptyborder8);
+      jpanel1.add(btnCenterError,cc.xy(19,1));
+
+      btnCenterGeometry.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-report-center-geometry.png"));
+      btnCenterGeometry.setName("btnCenterGeometry");
+      btnCenterGeometry.setToolTipText("_Center_geometry");
+      EmptyBorder emptyborder9 = new EmptyBorder(2,2,2,2);
+      btnCenterGeometry.setBorder(emptyborder9);
+      jpanel1.add(btnCenterGeometry,cc.xy(15,1));
+
+      btnZoomError.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-report-zoom-error.png"));
+      btnZoomError.setName("btnZoomError");
+      btnZoomError.setToolTipText("_Zoom");
+      EmptyBorder emptyborder10 = new EmptyBorder(2,2,2,2);
+      btnZoomError.setBorder(emptyborder10);
+      jpanel1.add(btnZoomError,cc.xy(17,1));
+
+      btnEraseErrorMarks.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-report-erase-errors.png"));
+      btnEraseErrorMarks.setName("btnEraseErrorMarks");
+      btnEraseErrorMarks.setToolTipText("_Erase_error_marks");
+      EmptyBorder emptyborder11 = new EmptyBorder(2,2,2,2);
+      btnEraseErrorMarks.setBorder(emptyborder11);
+      jpanel1.add(btnEraseErrorMarks,cc.xy(21,1));
+
+      addFillComponents(jpanel1,new int[]{ 2,4,6,8,10,12,14,16,18,20,22,24 },new int[0]);
       return jpanel1;
    }
 
@@ -245,13 +277,13 @@
       pnlParameters.setName("pnlParameters");
       jpanel1.add(pnlParameters,cc.xy(2,6));
 
-      jpanel1.add(createPanel4(),cc.xy(2,8));
       lblActionDescription.setName("lblActionDescription");
       jpanel1.add(lblActionDescription,cc.xy(2,4));
 
       lblActionTitle.setName("lblActionTitle");
       jpanel1.add(lblActionTitle,cc.xy(2,2));
 
+      jpanel1.add(createPanel4(),cc.xy(2,8));
       addFillComponents(jpanel1,new int[]{ 1,2,3 },new int[]{ 1,2,3,4,5,6,7,8,9 });
       return jpanel1;
    }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/DefaultJTopologyPlanProperties.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/DefaultJTopologyPlanProperties.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/DefaultJTopologyPlanProperties.java	(revision 727)
@@ -3,10 +3,14 @@
 import java.awt.Dimension;
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
+import java.net.URL;
+import java.util.List;
 import javax.swing.DefaultListModel;
+import javax.swing.ImageIcon;
 import javax.swing.JComponent;
 import javax.swing.event.ListSelectionEvent;
 import javax.swing.event.ListSelectionListener;
+import org.apache.commons.io.FilenameUtils;
 import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.i18n.I18nManager;
 import org.gvsig.tools.swing.api.ListElement;
@@ -14,6 +18,7 @@
 import org.gvsig.tools.swing.api.ToolsSwingManager;
 import org.gvsig.tools.swing.api.windowmanager.Dialog;
 import org.gvsig.tools.swing.api.windowmanager.WindowManager_v2;
+import org.gvsig.tools.swing.icontheme.IconTheme;
 import org.gvsig.topology.lib.api.TopologyDataSet;
 import org.gvsig.topology.lib.api.TopologyLocator;
 import org.gvsig.topology.lib.api.TopologyPlan;
@@ -80,6 +85,19 @@
         this.setPreferredSize(new Dimension(450, 300));
     }
 
+    @Override
+    public ImageIcon loadImage(String imageName) {
+        String name = FilenameUtils.getBaseName(imageName);
+        IconTheme theme = ToolsSwingLocator.getIconThemeManager().getDefault();
+        if (theme.exists(name)) {
+            return theme.get(name);
+        }
+        URL url = this.getClass().getResource("/"+imageName);
+        if (url == null) {
+            return null;
+        }
+        return new ImageIcon(url);
+    }
     
     private void translate() {
         ToolsSwingManager tsm = ToolsSwingLocator.getToolsSwingManager();
@@ -162,22 +180,25 @@
     }
 
     private void performAddDataSet() {
+        I18nManager i18n = ToolsLocator.getI18nManager();
         WindowManager_v2 winManager = (WindowManager_v2) ToolsSwingLocator.getWindowManager();
         SelectDataSetDialog panel = new SelectDataSetDialog();
         Dialog dlg = winManager.createDialog(
                 panel,
-                "_Select_a_dataset",
+                i18n.getTranslation("_Select_a_dataset"),
                 null, 
                 WindowManager_v2.BUTTONS_OK_CANCEL
         );
         panel.setDialog(dlg);
         dlg.show(WindowManager_v2.MODE.DIALOG);
         if( dlg.getAction()==WindowManager_v2.BUTTON_OK) {
-            TopologyDataSet dataSet = panel.getDataSet();
-            if( dataSet != null ) {
-                this.plan.addDataSet(dataSet);
-                DefaultListModel model = (DefaultListModel) this.lstDataSets.getModel();
-                model.addElement(dataSet);
+            List<TopologyDataSet> dataSets = panel.getDataSets();
+            if( dataSets != null ) {
+                for (TopologyDataSet dataSet : dataSets) {
+                    this.plan.addDataSet(dataSet);
+                    DefaultListModel model = (DefaultListModel) this.lstDataSets.getModel();
+                    model.addElement(dataSet);
+                }
             }
         }
     }
@@ -189,9 +210,10 @@
         if( lstDataSets.isSelectionEmpty() ) {
             return;
         }
+        int index = lstRules.getSelectedIndex();
         TopologyDataSet dataSet = (TopologyDataSet) lstDataSets.getSelectedValue();
         this.plan.removeDataSet(dataSet);
-        lstDataSets.remove(lstDataSets.getSelectedIndex());
+        ((DefaultListModel)(lstRules.getModel())).remove(index);
     }
 
     private void performAddRule() {
@@ -230,7 +252,7 @@
         int index = lstRules.getSelectedIndex();
         TopologyRule rule = (TopologyRule) ListElement.getSelected(lstRules);
         this.plan.removeRule(rule);
-        lstRules.remove(index);
+        ((DefaultListModel)(lstRules.getModel())).remove(index);
     }
 
 }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/SelectDataSetDialog.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/SelectDataSetDialog.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/SelectDataSetDialog.java	(revision 727)
@@ -1,9 +1,17 @@
 package org.gvsig.topology.swing.impl;
 
 import java.awt.Dimension;
+import java.awt.event.MouseAdapter;
+import java.awt.event.MouseEvent;
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Objects;
+import javax.swing.ImageIcon;
+import javax.swing.JLabel;
 import javax.swing.JTree;
 import javax.swing.event.TreeSelectionEvent;
 import javax.swing.event.TreeSelectionListener;
+import javax.swing.tree.DefaultTreeCellRenderer;
 import javax.swing.tree.TreePath;
 import org.apache.commons.lang3.StringUtils;
 import org.gvsig.tools.swing.api.ToolsSwingLocator;
@@ -37,6 +45,24 @@
                 performDataSetSelected();
             }
         });
+        this.treeDataSets.setCellRenderer(new DefaultTreeCellRenderer() {
+            @Override
+            public java.awt.Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {
+                JLabel label = (JLabel) super.getTreeCellRendererComponent(tree,value, selected, expanded, leaf, row, hasFocus);
+                ImageIcon icon = services.getTreeIcon(tree.getModel(),value);
+                label.setIcon(icon);
+                label.setText(Objects.toString(value, ""));
+                return label;
+            }
+        });
+        this.treeDataSets.addMouseListener(new MouseAdapter() {
+            @Override
+            public void mouseClicked(MouseEvent e) {
+                if( e.getButton()==MouseEvent.BUTTON1 && e.getClickCount()==2 ) {
+                    setVisible(false);
+                }
+            }
+        });
         this.setPreferredSize(new Dimension(350, 400));
         this.translate();
     }
@@ -65,35 +91,40 @@
         this.dialog.setButtonEnabled(WindowManager_v2.BUTTONS_OK, enabled);
     }
 
-    private TopologyDataSet getSelectedDataSet() {
-        TreePath path = treeDataSets.getSelectionPath();
-        Object element = path.getLastPathComponent();
-        if (element instanceof TopologyDataSet) {
-            TopologyDataSet dataSet = (TopologyDataSet) element;
-            return dataSet;
+    private List<TopologyDataSet> getSelectedDataSets() {
+        TreePath[] paths = treeDataSets.getSelectionPaths();
+        List<TopologyDataSet> datasets = new ArrayList<>();
+        for (TreePath path : paths) {
+            Object element = path.getLastPathComponent();
+            if (element instanceof TopologyDataSet) {
+                TopologyDataSet dataSet = (TopologyDataSet) element;
+                datasets.add(dataSet);
+            }
         }
-        return null;
+        return datasets;
     }
 
-    public TopologyDataSet getDataSet() {
-        TopologyDataSet dataSet = this.getSelectedDataSet();
-        if (dataSet == null) {
+    public List<TopologyDataSet> getDataSets() {
+        List<TopologyDataSet> dataSets = this.getSelectedDataSets();
+        if (dataSets == null || dataSets.isEmpty()) {
             return null;
         }
-        String name = this.txtName.getText();
-        if (!StringUtils.isEmpty(name)) {
-            dataSet.setName(name);
+        if( dataSets.size()==1 ) {
+            String name = this.txtName.getText();
+            if (!StringUtils.isEmpty(name)) {
+                dataSets.get(0).setName(name);
+            }
         }
-        return dataSet;
+        return dataSets;
     }
 
     public void performDataSetSelected() {
-        TopologyDataSet dataSet = this.getSelectedDataSet();
-        if (dataSet == null) {
+        List<TopologyDataSet> dataSets = this.getSelectedDataSets();
+        if (dataSets == null || dataSets.isEmpty()) {
             this.txtName.setText("");
             this.setOkButtonEnabled(false);
         } else {
-            this.txtName.setText(dataSet.getName());
+            this.txtName.setText(dataSets.get(0).getName());
             this.setOkButtonEnabled(true);
         }
     }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/DefaultJTopologyReport.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/DefaultJTopologyReport.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/DefaultJTopologyReport.java	(revision 727)
@@ -6,10 +6,13 @@
 import java.awt.event.ActionListener;
 import java.awt.event.MouseAdapter;
 import java.awt.event.MouseEvent;
+import java.net.URL;
+import java.util.ArrayList;
 import java.util.HashSet;
 import java.util.List;
 import java.util.Set;
 import javax.swing.DefaultComboBoxModel;
+import javax.swing.ImageIcon;
 import javax.swing.JComponent;
 import javax.swing.JMenuItem;
 import javax.swing.JPopupMenu;
@@ -22,6 +25,7 @@
 import javax.swing.event.TableModelEvent;
 import javax.swing.event.TableModelListener;
 import javax.swing.table.TableModel;
+import org.apache.commons.io.FilenameUtils;
 import org.apache.commons.lang3.StringUtils;
 import org.gvsig.expressionevaluator.ExpressionBuilder;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
@@ -39,6 +43,7 @@
 import org.gvsig.tools.swing.api.ToolsSwingLocator;
 import org.gvsig.tools.swing.api.ToolsSwingManager;
 import org.gvsig.tools.swing.api.task.TaskStatusController;
+import org.gvsig.tools.swing.icontheme.IconTheme;
 import org.gvsig.tools.task.TaskStatus;
 import org.gvsig.topology.lib.api.TopologyLocator;
 import org.gvsig.topology.lib.api.TopologyPlan;
@@ -70,25 +75,25 @@
     private class TopologyRuleActionParametersListener implements ActionListener {
 
         private final TopologyRule rule;
-        private final TopologyReportLine line;
+        private final List<TopologyReportLine> lines;
         private final TopologyRuleAction action;
         private final JDynForm form;
 
         public TopologyRuleActionParametersListener(
                 TopologyRule rule,
-                TopologyReportLine line,
+                List<TopologyReportLine> lines,
                 TopologyRuleAction action,
                 JDynForm form
         ) {
             this.action = action;
-            this.line = line;
+            this.lines = lines;
             this.rule = rule;
             this.form = form;
         }
 
         @Override
         public void actionPerformed(ActionEvent e) {
-            doExecuteRuleAction(rule, line, action, form);
+            doExecuteRuleAction(rule, lines, action, form);
         }
     }
 
@@ -96,25 +101,25 @@
     private class TopologyRuleActionListener implements ActionListener {
 
         private final TopologyRule rule;
-        private final TopologyReportLine line;
+        private final List<TopologyReportLine> lines;
         private final TopologyRuleAction action;
 
         public TopologyRuleActionListener(
                 TopologyRule rule,
-                TopologyReportLine line,
+                List<TopologyReportLine> lines,
                 TopologyRuleAction action
         ) {
             this.action = action;
-            this.line = line;
+            this.lines = lines;
             this.rule = rule;
         }
 
         @Override
         public void actionPerformed(ActionEvent e) {
             if ( this.action.hasParameters() ) {
-                doShowActionParametersPanel(this.rule, this.line, this.action);
+                doShowActionParametersPanel(this.rule, this.lines, this.action);
             } else {
-                doExecuteRuleAction(rule, line, action, null);
+                doExecuteRuleAction(rule, lines, action, null);
             }
         }
     }
@@ -141,18 +146,30 @@
         };
         this.tblErrors.setModel(this.linesModel);
         this.tblErrors.setAutoResizeMode(JTable.AUTO_RESIZE_LAST_COLUMN);
-        this.btnZoom.addActionListener(new ActionListener() {
+        this.btnZoomGeometry.addActionListener(new ActionListener() {
             @Override
             public void actionPerformed(ActionEvent e) {
-                doZoom();
+                doZoomGeometry();
             }
         });
-        this.btnCenter.addActionListener(new ActionListener() {
+        this.btnZoomError.addActionListener(new ActionListener() {
             @Override
             public void actionPerformed(ActionEvent e) {
-                doCenter();
+                doZoomError();
             }
         });
+        this.btnCenterGeometry.addActionListener(new ActionListener() {
+            @Override
+            public void actionPerformed(ActionEvent e) {
+                doCenterGeometry();
+            }
+        });
+        this.btnCenterError.addActionListener(new ActionListener() {
+            @Override
+            public void actionPerformed(ActionEvent e) {
+                doCenterError();
+            }
+        });
         this.btnRefresh.addActionListener(new ActionListener() {
             @Override
             public void actionPerformed(ActionEvent e) {
@@ -169,7 +186,7 @@
             @Override
             public void mouseClicked(MouseEvent e) {
                 if( e.getButton()==MouseEvent.BUTTON1 && e.getClickCount()==2 ) {
-                    doCenter();
+                    doCenterError();
                 }
             }
         });
@@ -207,6 +224,18 @@
                 doUpdateFilter();
             }
         });
+        this.btnShowForm.addActionListener(new ActionListener() {
+            @Override
+            public void actionPerformed(ActionEvent e) {
+                services.setShowFormWhenEdit(btnShowForm.isSelected());
+            }
+        });
+        this.btnEraseErrorMarks.addActionListener(new ActionListener() {
+            @Override
+            public void actionPerformed(ActionEvent e) {
+                services.addError(null);
+            }
+        });
         DefaultComboBoxModel<ListElement<TopologyRuleFactory>> modelRules = new DefaultComboBoxModel<>();
         modelRules.addElement(new ListElement<>(i18n.getTranslation("_Any_rule"), (TopologyRuleFactory)null));
         List<TopologyRuleFactory> factories = TopologyLocator.getTopologyManager().getRuleFactories();
@@ -244,18 +273,36 @@
         this.tabData.setEnabledAt(1, false);
 
     }
+    
+    @Override
+    public ImageIcon loadImage(String imageName) {
+        String name = FilenameUtils.getBaseName(imageName);
+        IconTheme theme = ToolsSwingLocator.getIconThemeManager().getDefault();
+        if (theme.exists(name)) {
+            return theme.get(name);
+        }
+        URL url = this.getClass().getResource("/"+imageName);
+        if (url == null) {
+            return null;
+        }
+        return new ImageIcon(url);
+    }
 
     private void translate() {
         ToolsSwingManager tsm = ToolsSwingLocator.getToolsSwingManager();
         tsm.translate(this.btnActions);
-        tsm.translate(this.btnCenter);
+        tsm.translate(this.btnCenterError);
+        tsm.translate(this.btnCenterGeometry);
         tsm.translate(this.btnRefresh);
         tsm.translate(this.btnShowErrors);
         tsm.translate(this.btnShowExceptions);
-        tsm.translate(this.btnZoom);
+        tsm.translate(this.btnZoomError);
+        tsm.translate(this.btnZoomGeometry);
+        tsm.translate(this.btnEraseErrorMarks);
         tsm.translate(this.btnVisibleExtentOnly);
         tsm.translate(this.btnParametersAccept);
         tsm.translate(this.btnParametersCancel);
+        tsm.translate(this.btnShowForm);
         tsm.translate(this.lblShow);
         tsm.translate(this.tabData);
     }
@@ -383,11 +430,18 @@
         if (n < 0) {
             return;
         }
-        TopologyReportLine line = this.linesModel.getLine(n);
-        TopologyRule rule = line.getRule();
+        int[] selectedRows = this.tblErrors.getSelectedRows();
+        TopologyRule rule = this.linesModel.getLine(selectedRows[0]).getRule();
         List<TopologyRuleAction> actions = rule.getActions();
         if (actions == null || actions.isEmpty()) {
             return;
+        }        
+        List<TopologyReportLine>lines = new ArrayList<>();
+        for (int selectedRow : selectedRows) {
+            TopologyReportLine line = this.linesModel.getLine(selectedRow);
+            if( line.getRule()==rule ) {
+                lines.add(line);
+            }
         }
         JPopupMenu menu = new JPopupMenu();
         for (TopologyRuleAction action : actions) {
@@ -397,7 +451,10 @@
             } else {
                 item = new JMenuItem(action.getName()); 
             }
-            item.addActionListener(new TopologyRuleActionListener(rule, line, action));
+            item.addActionListener(new TopologyRuleActionListener(rule, lines, action));
+            if( lines.size()>1 && action.hasParameters() ) {
+                item.setEnabled(false);
+            }
             menu.add(item);
         }
         menu.show(this.btnActions, 0, this.btnActions.getHeight());
@@ -405,7 +462,7 @@
 
     private void doExecuteRuleAction(
             TopologyRule rule,
-            TopologyReportLine line,
+            List<TopologyReportLine> lines,
             TopologyRuleAction action,
             JDynForm form
     ) {
@@ -416,17 +473,19 @@
                 form.getValues(parameters);
             }
         }
-        action.execute(rule, line, parameters);
+        for (TopologyReportLine line : lines) {
+            action.execute(rule, line, parameters);
+        }
         this.tabData.setEnabledAt(0, true);
         this.tabData.setEnabledAt(1, false);
         this.tabData.setSelectedIndex(0);
         this.pnlParameters.removeAll();
-        this.services.refreshView();
+        this.services.addError(null);
     }
 
     private void doShowActionParametersPanel(
             TopologyRule rule,
-            TopologyReportLine line,
+            List<TopologyReportLine> lines,
             TopologyRuleAction action
     ) {
         I18nManager i18n = ToolsLocator.getI18nManager();
@@ -456,14 +515,14 @@
                 }
             }
             this.btnParametersAccept.addActionListener(
-                new TopologyRuleActionParametersListener(rule, line, action, form)
+                new TopologyRuleActionParametersListener(rule, lines, action, form)
             );
         } catch (Exception ex) {
             LOGGER.warn("Can't show action parameters panel.",ex);
         }
     }
 
-    private void doZoom() {
+    private void doZoomGeometry() {
         int n = this.tblErrors.getSelectedRow();
         if (n < 0) {
             return;
@@ -473,7 +532,23 @@
         this.services.zoomTo(geom.getEnvelope());
     }
 
-    private void doCenter() {
+    private void doZoomError() {
+        int n = this.tblErrors.getSelectedRow();
+        if (n < 0) {
+            return;
+        }
+        TopologyReportLine line = this.linesModel.getLine(n);
+        Geometry geom = line.getError();
+        if( geom == null ) {
+            geom = line.getGeometry();
+            services.addError(null);
+        } else {
+            services.addError(geom);
+        }
+        this.services.zoomTo(geom.getEnvelope());
+    }
+
+    private void doCenterGeometry() {
         try {
             int n = this.tblErrors.getSelectedRow();
             if (n < 0) {
@@ -487,6 +562,26 @@
         }
     }
 
+    private void doCenterError() {
+        try {
+            int n = this.tblErrors.getSelectedRow();
+            if (n < 0) {
+                return;
+            }
+            TopologyReportLine line = this.linesModel.getLine(n);
+            Geometry geom = line.getError();
+            if( geom == null ) {
+                geom = line.getGeometry();
+                services.addError(null);
+            } else {
+                services.addError(geom);
+            }
+            this.services.centerTo(geom.centroid());
+        } catch (Exception ex) {
+            LOGGER.warn("Can't center topology error", ex);
+        }
+    }
+
     private void doRowSelected() {
         try {
             int n = this.tblErrors.getSelectedRow();
@@ -497,7 +592,8 @@
             if (line.getFeature1() == null) {
                 return;
             }
-            FeatureSelection selection = line.getDataSet1().getStore().getFeatureSelection();
+            this.services.addError(null);
+            FeatureSelection selection = line.getDataSet1().getFeatureStore().getFeatureSelection();
             selection.deselectAll();
             selection.select(line.getFeature1());
         } catch (Exception ex) {
